/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2024. All rights reserved.
 */

#ifndef DPC_IMPL_TYPE_ROADEDGE_H
#define DPC_IMPL_TYPE_ROADEDGE_H

#include "impl_type_uint32.h"
#include "dpc/impl_type_vector_roadedgesegment.h"

namespace dpc {
struct RoadEdge {
    ::UInt32 road_edge_id{ 0U };
    ::dpc::vector_RoadEdgeSegment road_edge_segment_list;

    static bool IsPlane()
    {
        return false;
    }


    using IsEnumerableTag = void;
    template<typename F>
    void enumerate(F& fun)
    {
        fun(road_edge_id);
        fun(road_edge_segment_list);
    }

    template<typename F>
    void enumerate(F& fun) const
    {
        fun(road_edge_id);
        fun(road_edge_segment_list);
    }

    template<typename F>
    void enumerate_internal(F& fun)
    {
        fun("road_edge_id", road_edge_id);
        fun("road_edge_segment_list", road_edge_segment_list);
    }

    template<typename F>
    void enumerate_internal(F& fun) const
    {
        fun("road_edge_id", road_edge_id);
        fun("road_edge_segment_list", road_edge_segment_list);
    }

    friend bool operator==(const ::dpc::RoadEdge& lhs, const ::dpc::RoadEdge& rhs) noexcept
    {
        return (lhs.road_edge_id == rhs.road_edge_id) && (lhs.road_edge_segment_list == rhs.road_edge_segment_list);
    }
};
} // namespace dpc


#endif // DPC_IMPL_TYPE_ROADEDGE_H
